import os
import sys
import numpy as np

root = "/home/students/zimmermann/Projects/ncr/corpus/"
files = os.listdir(root)

withintext_count = 0
outsidetext_count = 0
coref_count = 0
matches_entity = 0
span_dists = []
entity_counts = []

for f in files:
    if len(sys.argv)==1 or sys.argv[1] in f:
        old_file = open(root+f, "r").read()
        new_file = open(root+f, "w")
        
        words = []
        
        print(f)
        tokens, comps, coref = old_file.split("\n\n")
        
        new_file.write(tokens+"\n\n")
        
        split_tokens = tokens.split("\n")
        start_index = int(split_tokens[0][0])
        for token in split_tokens:
            words.append(token.strip().split("\t"))
            
        in_coref_chain = set()
        entities = set()
        coref_lines = coref.split("\n")
        for chain in coref_lines:
            spans = [int(index) for index in chain.split("\t") if index]
            if len(spans) > 2:
                for i in range(len(spans))[::2]:
                    in_coref_chain.add((spans[i], spans[i+1]))
            for i in range(len(spans))[::2]:
                entities.add((spans[i], spans[i+1]))
        entity_counts.append(len(entities)/len(split_tokens))
                    
        for comp in comps.split("\n"):
            spans = [int(index) for index in comp.strip().split("\t")]
            
            ## STATS
            if len(spans) > 2:
                if (spans[2], spans[3]) in in_coref_chain:
                    coref_count+=1
                if (spans[2], spans[3]) in entities:
                    matches_entity+=1
                span_dists.append(spans[0] - spans[3])
            
            #print(comp)
            if len(spans) > 2 and spans[0] - spans[3] == 2:
                if not (words[spans[3]+1][1] == "and" or words[spans[3]+1][1] == "or"):
                    new_file.write(comp+"\n")
                    withintext_count += 1
                else:
                    pass
                    #print(words[spans[2]:spans[3]+1],words[spans[3]+1],words[spans[0]:spans[1]+1])
            elif len(spans) > 2:
                new_file.write(comp+"\n")
                withintext_count += 1
            else:
                new_file.write(comp+"\n")
                outsidetext_count += 1
                    
        new_file.write("\n")
        new_file.write(coref)
        
        print("withintext/outsidetext: {}/{} (Total: {})".format(withintext_count, outsidetext_count, withintext_count+outsidetext_count))
        print("mean distance: {}".format(np.mean(span_dists)))
        print("mean candidates per token: {}".format(np.mean(entity_counts)))
        print("part of coref chain: {0:.2f}%".format(0 if withintext_count == 0 else coref_count/withintext_count*100))
        print("matches entity: {0:.2f}%".format(0 if withintext_count == 0 else matches_entity/withintext_count*100))
